# ClpConstraintAmpl Class Reference

Ampl Constraint Class. More...

`#include <ClpConstraintAmpl.hpp>`

Inheritance diagram for ClpConstraintAmpl:
[legend]
Collaboration diagram for ClpConstraintAmpl:
[legend]

List of all members.

## Public Member Functions
Stuff
virtual int | gradient (const ClpSimplex *model, const double *solution, double *gradient, double &functionValue, double &offset, bool useScaling=false, bool refresh=true) const
| Fills gradient.
virtual void | resize (int newNumberColumns)
| Resize constraint.
virtual void | deleteSome (int numberToDelete, const int *which)
| Delete columns in constraint.
virtual void | reallyScale (const double *columnScale)
| Scale constraint.
virtual int | markNonlinear (char *which) const
| Given a zeroed array sets nonampl columns to 1.
virtual int | markNonzero (char *which) const
| Given a zeroed array sets possible nonzero coefficients to 1.
virtual void | newXValues ()
| Say we have new primal solution - so may need to recompute.
Constructors and destructors
| ClpConstraintAmpl ()
| Default Constructor.
| ClpConstraintAmpl (int row, void *amplInfo)
| Constructor from ampl.
| ClpConstraintAmpl (const ClpConstraintAmpl &rhs)
| Copy constructor .
ClpConstraintAmpl & | operator= (const ClpConstraintAmpl &rhs)
| Assignment operator.
virtual | ~ClpConstraintAmpl ()
| Destructor.
virtual ClpConstraint * | clone () const
| Clone.
Gets and sets
virtual int | numberCoefficients () const
| Number of coefficients.
const int * | column () const
| Columns.
const double * | coefficient () const
| Coefficients.
## Private Attributes
Private member data
Ampl info
void * | amplInfo_
int * | column_
| Column.
double * | coefficient_
| Coefficients.
int | numberCoefficients_
| Number of coefficients in gradient.

## Detailed Description

Ampl Constraint Class.

Definition at line 17 of file ClpConstraintAmpl.hpp.

## Constructor & Destructor Documentation

ClpConstraintAmpl::ClpConstraintAmpl | ( |  | ) |

Default Constructor.

ClpConstraintAmpl::ClpConstraintAmpl | ( | int | row,
|  | void * | amplInfo |
| ) |  |  |

Constructor from ampl.

ClpConstraintAmpl::ClpConstraintAmpl | ( | const ClpConstraintAmpl & | rhs | ) |

Copy constructor .

virtual ClpConstraintAmpl::~ClpConstraintAmpl | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual int ClpConstraintAmpl::gradient | ( | const ClpSimplex * | model,
|  | const double * | solution,
|  | double * | gradient,
|  | double & | functionValue,
|  | double & | offset,
|  | bool | useScaling = `false`,
|  | bool | refresh = `true` |
| ) |  |  | const`[virtual]`

Fills gradient.

If Ampl then solution may be NULL, also returns true value of function and offset so we can use x not deltaX in constraint If refresh is false then uses last solution Uses model for scaling Returns non-zero if gradient udefined at current solution

Implements ClpConstraint.

virtual void ClpConstraintAmpl::resize | ( | int | newNumberColumns | ) | `[virtual]`

Resize constraint.

Implements ClpConstraint.

virtual void ClpConstraintAmpl::deleteSome | ( | int | numberToDelete,
|  | const int * | which |
| ) |  |  | `[virtual]`

Delete columns in constraint.

Implements ClpConstraint.

virtual void ClpConstraintAmpl::reallyScale | ( | const double * | columnScale | ) | `[virtual]`

Scale constraint.

Implements ClpConstraint.

virtual int ClpConstraintAmpl::markNonlinear | ( | char * | which | ) | const`[virtual]`

Given a zeroed array sets nonampl columns to 1.

Returns number of nonampl columns

Implements ClpConstraint.

virtual int ClpConstraintAmpl::markNonzero | ( | char * | which | ) | const`[virtual]`

Given a zeroed array sets possible nonzero coefficients to 1.

Returns number of nonzeros

Implements ClpConstraint.

virtual void ClpConstraintAmpl::newXValues | ( |  | ) | `[virtual]`

Say we have new primal solution - so may need to recompute.

Reimplemented from ClpConstraint.

ClpConstraintAmpl& ClpConstraintAmpl::operator= | ( | const ClpConstraintAmpl & | rhs | ) |

Assignment operator.

Reimplemented from ClpConstraint.

virtual ClpConstraint* ClpConstraintAmpl::clone | ( |  | ) | const`[virtual]`

Clone.

Implements ClpConstraint.

virtual int ClpConstraintAmpl::numberCoefficients | ( |  | ) | const`[virtual]`

Number of coefficients.

Implements ClpConstraint.

const int* ClpConstraintAmpl::column | ( |  | ) | const`[inline]`

Columns.

Definition at line 83 of file ClpConstraintAmpl.hpp.

const double* ClpConstraintAmpl::coefficient | ( |  | ) | const`[inline]`

Coefficients.

Definition at line 87 of file ClpConstraintAmpl.hpp.

## Member Data Documentation

void* ClpConstraintAmpl::amplInfo_`[private]`

Definition at line 97 of file ClpConstraintAmpl.hpp.

int* ClpConstraintAmpl::column_`[private]`

Column.

Definition at line 99 of file ClpConstraintAmpl.hpp.

double* ClpConstraintAmpl::coefficient_`[private]`

Coefficients.

Definition at line 101 of file ClpConstraintAmpl.hpp.

int ClpConstraintAmpl::numberCoefficients_`[private]`

Number of coefficients in gradient.

Definition at line 103 of file ClpConstraintAmpl.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.8.0/Cbc/src/ClpConstraintAmpl.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines